
import numpy
from matplotlib import pyplot
import os



def mySmooth(data, window):
  smoothed = numpy.zeros((len(data), 1))
  for d in range(len(data)):
    smoothed[d] = numpy.mean(data[max(0, d-window):d])
  return smoothed

def main():
  windowSize = 20
  directory = 'depthS/'


# Independent on target task
  targetTask = numpy.genfromtxt(os.path.join(directory, 'independent_1/avg_curve'))
  h2 = pyplot.plot(range(len(targetTask)), mySmooth(targetTask[:,1], windowSize), 'r-', label="Independent")

# Source task
  offset = 170
  srcTask = numpy.genfromtxt(os.path.join(directory, 'transferFromSubTask1/avg_curve'))
  h1 = pyplot.plot(range(offset, offset+len(srcTask)), mySmooth(srcTask[:,1], windowSize), 'b-', label="One stage from SubTask1")

# Transfer
  offset = 70
#  transferTask = numpy.genfromtxt(os.path.join(directory, 'transferFromSubTask2/avg_curve'))
#  h3 = pyplot.plot(range(offset, offset+len(transferTask)), mySmooth(transferTask[:,1], windowSize), 'g-', label="One stage from SubTask2")

# Other
  offset = 160
#  otherTask = numpy.genfromtxt(os.path.join(directory, 'twoStageTransfer/avg_curve'))
#  h4 = pyplot.plot(range(offset, offset+len(otherTask)), mySmooth(otherTask[:,1], windowSize), 'k-', label='Two stage transfer')



#title1 = 'Task 1: Line ghosts'
#title2 = 'Task 2: Infinite edible time'

#title = title1 + '\n' + title2
  title = 'Two stage transfer'

  pyplot.legend(loc=4)
  pyplot.title(title)
  pyplot.xlabel('Episode') 
  pyplot.ylabel('Reward')

  pyplot.savefig("/home/sanmit/Desktop/graph.png")

  pyplot.show()

if __name__=="__main__":
  main()

